#ifndef QUATERNION_H
#define QUATERNION_H
/*
	Animadead: A Skeletal Animation Library
	Copyright (C) 2005 John C. Butterfield

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

	John C. Butterfield
	johnb003@hotmail.com
*/

namespace ad
{
	class Quaternion
	{
	public:
		float w, x, y, z;

		Quaternion();
		Quaternion(float w, float x, float y, float z);
		Quaternion(float rotX, float rotY, float rotZ);
		void Set(float w, float x, float y, float z);

		void Slerp(const Quaternion &to, float t);
		void Slerp(const Quaternion &from, const Quaternion &to, float t);
		void Lerp(const Quaternion &to, float t);
	
//		float Magnitude();
//		Quaternion Inverse();
	
	   	Quaternion &operator*=(const Quaternion &q);
	   	friend Quaternion operator*(const Quaternion &q1, const Quaternion &q2);
	};
}

#endif //QUATERNION_H
