#ifndef VECTOR3_H
#define VECTOR3_H
/*
	Animadead: A Skeletal Animation Library
	Copyright (C) 2005 John C. Butterfield

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

	John C. Butterfield
	johnb003@hotmail.com
*/

#include <iostream>

namespace ad
{
    class Vector3
    {
    public:
    	Vector3();
    	Vector3(float x, float y, float z);
    	void set(float x, float y, float z);
    
    	Vector3 &operator+=(const Vector3 &v);
    	Vector3 &operator-=(const Vector3 &v);
    	Vector3 &operator*=(float v);
    	Vector3 &operator/=(float v);
    	void Normalize();
    
    	friend Vector3 operator+(const Vector3 &v1, const Vector3 &v2);
    	friend Vector3 operator-(const Vector3 &v1, const Vector3 &v2);
    	friend Vector3 operator*(const Vector3 &v, float f);
    	friend Vector3 operator/(const Vector3 &v, float f);
    
    	float x,y,z;
    };

	std::ostream &operator<<(std::ostream &os, const ad::Vector3 &v);
}    

#endif // VECTOR3_H
